import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject
base.disableMouse ()

def make_mouse_move_task ():
    mouse = base.mouseWatcherNode
    old   = [ None, None ]
    if mouse.hasMouse ():
        old = [ mouse.getMouseX (), mouse.getMouseY () ]
    def mouse_move_task (task):
        if mouse.hasMouse ():
            new = [ mouse.getMouseX (), mouse.getMouseY () ]
            if new != old:
                if not (None in old):
                    messenger.send ('mouse-move',
                                    [(new [0] - old [0],
                                      new [1] - old [1])])
                old [0], old [1] = new
        return task.cont
    return mouse_move_task

# Tampoco hay nada para 'aceptar' funciones libres
def accept_fn (event, function, *a, **k):
    obj = DirectObject ()
    obj.function = function
    obj.accept (event, obj.function, *a, **k)
    return obj

def print_sth (something):
    print something

accept_fn ('mouse-move', print_sth)
taskMgr.add (make_mouse_move_task (), 'mouse-move')
run ()
